/*
 * Websock: high-performance binary WebSockets
 * Copyright (C) 2011 Joel Martin
 * Licensed under LGPL-3 (see LICENSE.txt)
 *
 * Websock is similar to the standard WebSocket object but Websock
 * enables communication with raw TCP sockets (i.e. the binary stream)
 * via websockify. This is accomplished by base64 encoding the data
 * stream between Websock and websockify.
 *
 * Websock has built-in receive queue buffering; the message event
 * does not contain actual data but is simply a notification that
 * there is new data available. Several rQ* methods are available to
 * read binary data off of the receive queue.
 */
function Websock(){"use strict";function e(){return $}function t(){return U}function n(){return x}function i(e){x=e}function o(){return U.length-x}function r(){return U[x]}function a(){return U[x++]}function s(e){0===x?U.unshift(e):(x-=1,U[x]=e)}function c(){return(U[x++]<<8)+U[x++]}function l(){return(U[x++]<<24)+(U[x++]<<16)+(U[x++]<<8)+U[x++]}function d(e){"undefined"==typeof e&&(e=o());var t=U.slice(x,x+e);return x+=e,t.map(function(e){return String.fromCharCode(e)}).join("")}function u(e){return"undefined"==typeof e&&(e=o()),x+=e,U.slice(x-e,x)}function f(e,t){return t?U.slice(x+e,x+t):U.slice(x+e)}function h(e,t,n){var i=U.length-x;if(t>i){if(n){if(n>x)throw"rQwait cannot backup "+n+" bytes";x-=n}return!0}return!1}function p(){return Base64.encode($)}function g(e){U=U.concat(Base64.decode(e,0))}function m(){return 0!==D.bufferedAmount&&Util.Debug("bufferedAmount: "+D.bufferedAmount),D.bufferedAmount<E.maxBufferedAmount?($.length>0&&(D.send(p($)),$=[]),!0):(Util.Info("Delaying send, bufferedAmount: "+D.bufferedAmount),!1)}function v(e){return $=$.concat(e),m()}function _(e){E.send(e.split("").map(function(e){return e.charCodeAt(0)}))}function b(e){try{g(e.data),o()>0?(Q.message(),U.length>S&&(U=U.slice(x),x=0)):Util.Debug("Ignoring empty message")}catch(t){"undefined"!=typeof t.stack?Util.Warn("recv_message, caught exception: "+t.stack):"undefined"!=typeof t.description?Util.Warn("recv_message, caught exception: "+t.description):Util.Warn("recv_message, caught exception:"+t),"undefined"!=typeof t.name?Q.error(t.name+": "+t.message):Q.error(t)}}function y(e,t){Q[e]=t}function w(){U=[],x=0,$=[],D=null}function A(e){w(),D=B?{}:new WebSocket(e,"base64"),D.onmessage=b,D.onopen=function(){Util.Debug(">> WebSock.onopen"),D.protocol&&Util.Info("Server chose sub-protocol: "+D.protocol),Q.open(),Util.Debug("<< WebSock.onopen")},D.onclose=function(e){Util.Debug(">> WebSock.onclose"),Q.close(e),Util.Debug("<< WebSock.onclose")},D.onerror=function(e){Util.Debug(">> WebSock.onerror: "+e),Q.error(e),Util.Debug("<< WebSock.onerror")}}function I(){D&&((D.readyState===WebSocket.OPEN||D.readyState===WebSocket.CONNECTING)&&(Util.Info("Closing WebSocket connection"),D.close()),D.onmessage=function(){})}function k(e){return B=!0,E.send=e,E.close=function(){},b}function C(){return E.maxBufferedAmount=200,E.get_sQ=e,E.get_rQ=t,E.get_rQi=n,E.set_rQi=i,E.rQlen=o,E.rQpeek8=r,E.rQshift8=a,E.rQunshift8=s,E.rQshift16=c,E.rQshift32=l,E.rQshiftStr=d,E.rQshiftBytes=u,E.rQslice=f,E.rQwait=h,E.flush=m,E.send=v,E.send_string=_,E.on=y,E.init=w,E.open=A,E.close=I,E.testMode=k,E}var E={},D=null,U=[],x=0,S=1e4,$=[],Q={message:function(){},open:function(){},close:function(){},error:function(){}},B=!1;return C()}window.WebSocket&&!window.WEB_SOCKET_FORCE_FLASH?Websock_native=!0:window.MozWebSocket&&!window.WEB_SOCKET_FORCE_FLASH?(Websock_native=!0,window.WebSocket=window.MozWebSocket):(Websock_native=!1,function(){function e(){return"undefined"!=typeof INCLUDE_URI?INCLUDE_URI:"include/"}var t="<script src='"+e(),n="'></script>",i="";window.WEB_SOCKET_SWF_LOCATION=e()+"web-socket-js/WebSocketMain.swf",Util.Engine.trident&&(Util.Debug("Forcing uncached load of WebSocketMain.swf"),window.WEB_SOCKET_SWF_LOCATION+="?"+Math.random()),i+=t+"web-socket-js/swfobject.js"+n,i+=t+"web-socket-js/web_socket.js"+n,document.write(i)}());